import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["button", "leftAddon", "rightAddon", "leftIcon", "rightIcon", "children", "onClickLeftIcon", "onClickRightIcon", "size"];
import { forwardRef } from 'react';
import PropTypes from 'prop-types';
import InputButton from './Wrappers/Button/InputButton';
import InputAddons from './Wrappers/Addons/InputAddons';
import InputIcons from './Wrappers/Icons/InputIcons';
import Input, { inputStates, inputSizes } from './Component';
import { SIZES } from '../config';
import { jsx as _jsx } from "react/jsx-runtime";
var BaseInput = /*#__PURE__*/forwardRef(function (_ref, forwardedRef) {
  var button = _ref.button,
      leftAddon = _ref.leftAddon,
      rightAddon = _ref.rightAddon,
      leftIcon = _ref.leftIcon,
      rightIcon = _ref.rightIcon,
      children = _ref.children,
      onClickLeftIcon = _ref.onClickLeftIcon,
      onClickRightIcon = _ref.onClickRightIcon,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? SIZES.MEDIUM : _ref$size,
      inputProps = _objectWithoutPropertiesLoose(_ref, _excluded);

  return /*#__PURE__*/_jsx(InputButton, {
    button: button,
    children: /*#__PURE__*/_jsx(InputAddons, {
      leftAddon: leftAddon,
      rightAddon: rightAddon,
      shape: inputProps.shape,
      size: size,
      children: /*#__PURE__*/_jsx(InputIcons, {
        leftIcon: leftIcon,
        rightIcon: rightIcon,
        onClickLeftIcon: onClickLeftIcon,
        onClickRightIcon: onClickRightIcon,
        children: /*#__PURE__*/_jsx(Input, _extends({
          ref: forwardedRef
        }, inputProps, {
          size: size
        }))
      })
    })
  });
});
export default BaseInput;
export { inputSizes, inputStates, BaseInput };